/*
    WinCdArb - Windows CdRom Device Arbiter service

    Copyright (C) 2007-2019 GuinpinSoft inc <wincdarb@makemkv.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#ifndef WINCDARB_SRV_H_INCLUDED
#define WINCDARB_SRV_H_INCLUDED

#include <wincdarb/winipc.h>
#include <wincdarb/cdarbdefs.h>

void    WINAPI WinCdArbServerInit(void);
HRESULT WINAPI WinCdArbServerLoop(void);
PCSTR   WINAPI WinCdArbVersionString();

static const ULONG_PTR InstallExePathCopyThis = 1;
static const ULONG_PTR InstallExePathUseThis = 2;
static const ULONG_PTR InstallExePathCopyTiny = 3;

HRESULT WINAPI WinCdArbInstall(PCWSTR ExePath);
void    WINAPI WinCdArbServiceControlMain();
HRESULT WINAPI WinCdArbServiceStart();
HRESULT WINAPI WinCdArbServiceStop();

HRESULT WINAPI WinCdArbClientTest(PCWSTR Arg);

extern const PCWSTR WinCdArbServiceDisplayName;
extern const PCWSTR WinCdArbServiceDescription;
extern const PCSTR  WinCdArbServiceLicense;


#endif // WINCDARB_SRV_H_INCLUDED
