/*
    WinCdArb - Windows CdRom Device Arbiter service

    Copyright (C) 2007-2019 GuinpinSoft inc <wincdarb@makemkv.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#ifndef WIN_CDARB_DEFS_H_INCLUDED
#define WIN_CDARB_DEFS_H_INCLUDED

typedef enum _WinCdArbCommandCode
{
    WinCdArbCmdGetVersion = 0,
    WinCdArbCmdGetHandle = 1,
    WinCdArbCmdMaxValue
} WinCdArbCommandCode;


#define WINCDARB_PORT_NAME      L"\\Device\\CdRomArbiterPort"
#define WINCDARB_SERVICE_NAME   L"CdRomArbiterService"

typedef struct _WINCDARB_CMD_COMMON
{
    ULONG   CommandCode;
} WINCDARB_CMD_COMMON;

typedef struct _WINCDARB_CMD_GET_VERSION_RESPONSE
{
    ULONG   CommandCode;
    ULONG   Version;
    CHAR    VersionString[0x100];
} WINCDARB_CMD_GET_VERSION_RESPONSE;

#define WINCDARB_MAX_DEVICE_NAME_LENGTH 0x80

typedef struct _WINCDARB_CMD_GET_HANDLE_REQUEST
{
    ULONG   CommandCode;
    ULONG   DeviceNameLength;
    WCHAR   DeviceName[WINCDARB_MAX_DEVICE_NAME_LENGTH];
} WINCDARB_CMD_GET_HANDLE_REQUEST;

typedef struct _WINCDARB_CMD_GET_HANDLE_RESPONSE
{
    ULONG   CommandCode;
    ULONG   ErrorCode;
    ULONG64 Handle;
} WINCDARB_CMD_GET_HANDLE_RESPONSE;

#endif // WIN_CDARB_DEFS_H_INCLUDED
