/*
    WinCdArb - Windows CdRom Device Arbiter service

    Copyright (C) 2007-2019 GuinpinSoft inc <wincdarb@makemkv.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#ifndef WINIPC_H_INCLUDED
#define WINIPC_H_INCLUDED

#define WinIpcMaxMessageLength 0x120

typedef BOOLEAN (WINAPI *WinIpcProcessMessageRoutine)(PVOID Context,ULONG ProcessId,PUCHAR Message,PULONG MessageLength);

#ifdef __cplusplus
extern "C" {
#endif

// Server
HRESULT  WINAPI WinIpcCreatePort(PHANDLE PortHandle,PCWSTR PortName);
HRESULT  WINAPI WinIpcServerLoop(HANDLE PortHandle,WinIpcProcessMessageRoutine ProcessMessage,PVOID Context);
void     WINAPI WinIpcClearExitServerLoopFlag();
void     WINAPI WinIpcSetExitServerLoopFlag();

// Client
HRESULT  WINAPI WinIpcClientRequest(PCWSTR PortName,PUCHAR Message,PULONG MessageLength);


#ifdef __cplusplus
}
#endif


#endif // WINIPC_H_INCLUDED
