/*
    WinCdArb - Windows CdRom Device Arbiter service

    Copyright (C) 2007-2019 GuinpinSoft inc <wincdarb@makemkv.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <windows.h>
#include <winnt.h>
#include <stdio.h>
#include "cdarbsrv.h"

//
// "Tiny" build - only service code, no dependencies, even on CRT library
//

static const char infoText[] =
    "\r\n"
    "  This image contains only core service code, no installer or test code.\r\n";

static inline void cnputs(HANDLE h,const char* str)
{
    DWORD wr;
    WriteFile(h,str,(DWORD)strlen(str),&wr,NULL);
}

static inline void cnputw(HANDLE h,const wchar_t* str)
{
    DWORD wr;
    for (unsigned int i=0; str[i]!=0; i++)
    {
        UCHAR tmp;
        tmp = (UCHAR)str[i];
        WriteFile(h,&tmp,1,&wr,NULL);
    }
}

extern "C" int __cdecl wmainCRTStartup()
{
    HANDLE h;

    WinCdArbServiceControlMain();

    h = GetStdHandle(STD_OUTPUT_HANDLE);
    if (INVALID_HANDLE_VALUE==h)
    {
        h = GetStdHandle(STD_ERROR_HANDLE);
    }
    if (INVALID_HANDLE_VALUE!=h)
    {
        cnputs(h,"Service name : ");
        cnputw(h,WinCdArbServiceDisplayName);
        cnputs(h,"\r\n");
        cnputs(h,"Description  : ");
        cnputw(h,WinCdArbServiceDescription);
        cnputs(h,"\r\n");
        cnputs(h,"Version      : ");
        cnputs(h,WinCdArbVersionString());
        cnputs(h,"\r\n");
        cnputs(h,infoText);
        cnputs(h,WinCdArbServiceLicense);
    }

    ExitProcess(0);
    return 0;
}

