/*
    WinCdArb - Windows CdRom Device Arbiter service

    Copyright (C) 2007-2019 GuinpinSoft inc <wincdarb@makemkv.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include "winntapi.h"
#include "cdarbsrv.h"

HRESULT WINAPI WinCdArbClientTest(PCWSTR arg)
{
    union _u
    {
        WINCDARB_CMD_GET_HANDLE_REQUEST     req_get_handle;
        WINCDARB_CMD_GET_HANDLE_RESPONSE    res_get_handle;
    } u;
    ULONG size;

    memset(&u.req_get_handle,0,sizeof(u.req_get_handle));
    u.req_get_handle.CommandCode = WinCdArbCmdGetHandle;
    memcpy(u.req_get_handle.DeviceName,L"\\Device\\CdRom0",15*sizeof(WCHAR));
    if (NULL!=arg)
    {
        wchar_t* dst = u.req_get_handle.DeviceName + 13;
        for (PCWSTR p = arg;*p!=0;p++)
        {
            *dst = *p;
            dst++;
        }
        *dst = 0;
    }
    u.req_get_handle.DeviceNameLength = (ULONG)wcslen(u.req_get_handle.DeviceName);

    size = sizeof(u.req_get_handle);
    return WinIpcClientRequest(WINCDARB_PORT_NAME,(PUCHAR)&u.req_get_handle,&size);
}

