/*
    WinCdArb - Windows CdRom Device Arbiter service

    Copyright (C) 2007-2019 GuinpinSoft inc <wincdarb@makemkv.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include "winntapi.h"
#include "ntipc.h"
#include <wincdarb/winipc.h>

C_ASSERT(WinIpcMaxMessageLength <= IPC_MAX_DATA_LENGTH);

NTSTATUS WINAPI WinIpcClientRequest(PCWSTR PortName,PUCHAR Message,PULONG MessageLength)
{
    NTSTATUS        status;
    HANDLE          hPort;
    UNICODE_STRING  ustrName;
    SECURITY_QUALITY_OF_SERVICE securityQos;

    memset(&securityQos,0,sizeof(securityQos));
    securityQos.Length = sizeof(securityQos);
    securityQos.ImpersonationLevel = SecurityAnonymous;
    securityQos.ContextTrackingMode = SECURITY_STATIC_TRACKING;
    securityQos.EffectiveOnly = FALSE;

    RtlInitUnicodeString(&ustrName,(PWSTR)PortName);
    status = NtConnectPort(&hPort,&ustrName,&securityQos,NULL,NULL,NULL,Message,MessageLength);
    if (STATUS_SUCCESS!=status) return status;

    NtClose(hPort);

    return STATUS_SUCCESS;
}

